local prots = {data.raw['transport-belt'], data.raw['underground-belt'], data.raw['splitter']}

-- local k_ef = 15/(40/3) -- some vibration!
local k_ef = 1

local speed_of_prot = {}
  -- belts
  speed_of_prot['transport-belt'] = 
  {
    ['black-transport-belt'] = settings.startup["doublespeedbelts-graybelt-multiplier"].value, 
    ['transport-belt'] = settings.startup["doublespeedbelts-yellowbelt-multiplier"].value, 
    ['fast-transport-belt'] = settings.startup["doublespeedbelts-redbelt-multiplier"].value, 
    ['express-transport-belt'] = settings.startup["doublespeedbelts-bluebelt-multiplier"].value,
    ['turbo-transport-belt'] = settings.startup["doublespeedbelts-purplebelt-multiplier"].value,
    ['ultimate-transport-belt'] = settings.startup["doublespeedbelts-greenbelt-multiplier"].value,
    
  }
  -- underground belts
  speed_of_prot['underground-belt'] = 
  {
    ['black-underground-belt'] = settings.startup["doublespeedbelts-graybelt-multiplier"].value, 
    ['underground-belt'] = settings.startup["doublespeedbelts-yellowbelt-multiplier"].value, 
    ['fast-underground-belt'] = settings.startup["doublespeedbelts-redbelt-multiplier"].value, 
    ['express-underground-belt'] = settings.startup["doublespeedbelts-bluebelt-multiplier"].value,
    ['turbo-underground-belt'] = settings.startup["doublespeedbelts-purplebelt-multiplier"].value,
    ['ultimate-underground-belt'] = settings.startup["doublespeedbelts-greenbelt-multiplier"].value
  }
  -- splitters
  speed_of_prot['splitter'] = 
  {
    ['black-splitter'] = settings.startup["doublespeedbelts-graybelt-multiplier"].value, 
    ['splitter'] = settings.startup["doublespeedbelts-yellowbelt-multiplier"].value, 
    ['fast-splitter'] = settings.startup["doublespeedbelts-redbelt-multiplier"].value, 
    ['express-splitter'] = settings.startup["doublespeedbelts-bluebelt-multiplier"].value,
    ['turbo-splitter'] = settings.startup["doublespeedbelts-purplebelt-multiplier"].value,
    ['ultimate-splitter'] = settings.startup["doublespeedbelts-greenbelt-multiplier"].value
  }

-- animation_speed_coefficient = 32 -- must be by vanilla always 32
-- speed = 0.03125 is a tile/sec

for i, prot in pairs (prots) do
  for type_name, typ in pairs (speed_of_prot) do
    for prot_name, multiplier in pairs (typ) do
      if prot[prot_name] then
        local my_prot = prot[prot_name]
        my_prot.speed = multiplier * 0.03125
      end
    end
  end
end
